#include "dll.ch"
#include "inkey.ch"
#include "common.ch"

/*
 * Einfache Test-Schleife zum Abfragen/Setzen der CPU
 * 0 - Beendet Beispiel
 * 1 = Nur Erste CPU, 2 = 2. CPU, 4 = 3. CPU, 16 = 8. CPU
 */
PROCEDURE Main
LOCAL nCpu := 1 , nMax := 0
LOCAL aCPU := {1,2,4,8,16,32,64,128,256,512}

#IFDEF __XPP__
   Thread():new():start("stress")
#ELSE
   REQUEST HB_GT_WIN_DEFAULT
   Hb_ThreadStart({|| Stress() } )
#ENDIF

   CLS
   nMax := CHECKCPU()
   ? "CPU have "+ STR(nMax) + " Core"

   DO WHILE .T.
       nCpu := SmpGetCPU()

       IF EMPTY(nCpu)
         nCpu := 1
       ENDIF

       ? "Apps run under CPU(s): " + STR(nCpu)

       INPUT "New CPU-Mask: (0 => End)" TO nCpu

       IF nCpu = 0
          EXIT
       ENDIF

       IF ASCAN(aCPU, {|e| e = nCpu }) > 0
          IF SmpSetCPU(nCpu) = 0
             ? "Errorn CPU-Mask :" + STR(nCpu)
          ENDIF
       ENDIF
   ENDDO
RETURN

FUNCTION SmpGetCPU()
LOCAL i
*#IFDEF __XPP__
*    i := DllCall("Xpprt1.dll",DLL_CDECL, "_sysGetCPU")
*#ELSE
   local ProcMask := 0
   local SysMask := 0
   GetProcessAffinityMask(@ProcMask,@SysMask)
   i := ProcMask

   i := Mask2CPU(i)
   i --
*#ENDIF
RETURN i

FUNCTION SmpSetCPU(nCpuMask)
LOCAL rc
*#IFDEF __XPP__
*    rc := DllCall("Xpprt1.dll",DLL_CDECL, "_sysSetCPU", nCpuMask)
*#ELSE
    rc := SetProcessAffinityMask(nCpuMask)
*#ENDIF
RETURN rc

PROCEDURE Stress()
LOCAL a:= {3,2,1,0}
    DO WHILE .T.
        ASort(a)
    ENDDO
RETURN

* ------------------------------------------------------------------------ *
//
// Syntax need libs=hbxpp
//

FUNCTION GetCurrentProcess()
LOCAL rc := 0
#IFDEF __XPP__
   rc := dllcall( "Kernel32.dll", DLL_STDCALL, "GetCurrentProcess" )
#ELSE
   rc := HMG_CallDLL ( "Kernel32.dll", HB_DYN_CALLCONV_STDCALL, "GetCurrentProcess" )
#ENDIF
RETURN rc

FUNCTION GetProcessAffinityMask(ProcMask,SysMask)
LOCAL rc := 0
LOCAL ip := 0
LOCAL bOldError

   bOldError := ERRORBLOCK( { | e | BREAK( e ) } )
   BEGIN SEQUENCE
#IFDEF __XPP__
      ip := GetCurrentProcess()
      rc := dllcall( "Kernel32.dll", DLL_STDCALL, "GetProcessAffinityMask",ip,@ProcMask,@SysMask)
#ELSE
      rc := HMG_CallDLL ( "Kernel32.dll", HB_DYN_CALLCONV_STDCALL, "GetProcessAffinityMask",ip,@ProcMask,@SysMask)
#ENDIF
   END SEQUENCE
   ERRORBLOCK( bOldError )

   IF EMPTY(rc)
      Msgbox("Error GetProcessAffinityMask"+STR(ProcMask) ,STR(GetLastError() ))
      rc := 0
   ENDIF
RETURN rc

FUNCTION SetProcessAffinityMask(nProc)
LOCAL rc := 0
LOCAL ip := 0
LOCAL bOldError

ALTD()

   bOldError := ERRORBLOCK( { | e | BREAK( e ) } )
   BEGIN SEQUENCE
#IFDEF __XPP__
      ip := GetCurrentProcess()
      rc := dllcall( "Kernel32.dll", DLL_STDCALL, "SetProcessAffinityMask",ip,nProc)
#ELSE
      rc := HMG_CallDLL ( "Kernel32.dll", HB_DYN_CALLCONV_STDCALL, "SetProcessAffinityMask",ip,nProc)
#ENDIF
   END SEQUENCE
   ERRORBLOCK( bOldError )

   IF EMPTY(rc)
      Msgbox("Error SetProcessAffinityMask"+STR(nProc),STR(GetLastError() ))
      rc := 0
   ENDIF

RETURN rc

* ------------------------------------------------------------------------ *

#IFDEF __XPP__
FUNCTION GetLastError()
LOCAL rc := 0
   rc := dllcall( "Kernel32.dll", DLL_STDCALL, "GetLastError")
RETURN rc
#ENDIF

FUNCTION switchcpu( nMax )
LOCAL nWorkCPU
LOCAL nStep

   DEFAULT nMax TO 1

#IFDEF __XPP__
   IF nMax > 1
      nStep := RandomInt( 2, nMax )
   ELSE
      nStep := RandomInt( 1, nMax )
   ENDIF
#ELSE
   IF nMax > 1
      nStep := Int(Random( 2, nMax ))
   ELSE
      nStep := Int(Random( 1, nMax ))
   ENDIF
#ENDIF

   IF nStep = 1
      SmpSetCPU( 1 )
   ELSE
      nWorkCPU := 2 ^ INT( nStep - 1 )

      IF SmpSetCPU( nWorkCPU ) = 0
         SmpSetCPU( 1 )
      ENDIF
   ENDIF
   nWorkCPU := SmpGetCPU()

RETURN nStep

FUNCTION CHECKCPU()
LOCAL nStep
LOCAL nMaxCPU

   nStep := 1
   DO WHILE .T.
      nMaxCPU := 2 ^ nStep
      IF SmpSetCPU( nMaxCPU ) = 0
         EXIT
      ENDIF
      nStep ++
   ENDDO

#IFDEF __XPP__
#ELSE
   nStep := Mask2CPU(nStep)
#ENDIF

RETURN nStep

FUNCTION Mask2CPU(nMask)
LOCAL nCPU := 1
LOCAL nRest := nMask

   DO WHILE nRest >= 1
      nRest := nRest / 2
      nCPU++
   ENDDO

RETURN nCPU

*
*
*